#ifndef BEZIER_H
#define BEZIER_H

#include "mbed.h"

#define WIDTH 0.0005

class BezierCurve{
public:
    BezierCurve();
    
    void set(double (&pX)[4],double (&pY)[4],double (&pT)[4]);
    double callX(double ratio);
    double callY(double ratio);
    double callT(double ratio);
    
    double range(double start, double stop);
    
    double length;
    
private:
    
    
    double pointX[4];
    double pointY[4];
    double pointT[4];
    
};


#endif